<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ManagedUtil.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.jmx</a> &gt; <span class="el_source">ManagedUtil.java</span></div><h1>ManagedUtil.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.jmx;

import java.util.Enumeration;

import javax.management.JMException;
import javax.management.MBeanServer;
import javax.management.ObjectName;

import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;
import org.apache.log4j.jmx.HierarchyDynamicMBean;
import org.apache.log4j.spi.LoggerRepository;

/**
 * Shared utilities
 */
<span class="nc" id="L35">public class ManagedUtil {</span>
    /**
     * Register the log4j JMX mbeans. Set environment variable
     * &quot;zookeeper.jmx.log4j.disable&quot; to true to disable registration.
     * @see http://logging.apache.org/log4j/1.2/apidocs/index.html?org/apache/log4j/jmx/package-summary.html
     * @throws JMException if registration fails
     */
    public static void registerLog4jMBeans() throws JMException {
<span class="pc bpc" id="L43" title="1 of 2 branches missed.">        if (Boolean.getBoolean(&quot;zookeeper.jmx.log4j.disable&quot;) == true) {</span>
<span class="nc" id="L44">            return;</span>
        }
        
<span class="fc" id="L47">        MBeanServer mbs = MBeanRegistry.getInstance().getPlatformMBeanServer();</span>

        // Create and Register the top level Log4J MBean
<span class="fc" id="L50">        HierarchyDynamicMBean hdm = new HierarchyDynamicMBean();</span>

<span class="fc" id="L52">        ObjectName mbo = new ObjectName(&quot;log4j:hiearchy=default&quot;);</span>
<span class="fc" id="L53">        mbs.registerMBean(hdm, mbo);</span>

        // Add the root logger to the Hierarchy MBean
<span class="fc" id="L56">        Logger rootLogger = Logger.getRootLogger();</span>
<span class="fc" id="L57">        hdm.addLoggerMBean(rootLogger.getName());</span>

        // Get each logger from the Log4J Repository and add it to
        // the Hierarchy MBean created above.
<span class="fc" id="L61">        LoggerRepository r = LogManager.getLoggerRepository();</span>
<span class="fc" id="L62">        Enumeration enumer = r.getCurrentLoggers();</span>
<span class="fc" id="L63">        Logger logger = null;</span>

<span class="fc bfc" id="L65" title="All 2 branches covered.">        while (enumer.hasMoreElements()) {</span>
<span class="fc" id="L66">           logger = (Logger) enumer.nextElement();</span>
<span class="fc" id="L67">           hdm.addLoggerMBean(logger.getName());</span>
        }
<span class="fc" id="L69">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>